lowess.c File Reference
`#include <math.h>`

## Macros

#define | FALSE false
#define | TRUE true

## Typedefs

typedef bool | Rboolean

## Functions

static void | clowess (double *x, double *y, int n, double f, int nsteps, double delta, double *ys, double *rw, double *res)
static double | fcube (double x)
static double | fmax2 (double d1, double d2)
static double | fsquare (double x)
static double | imax2 (double i1, double i2)
static double | imin2 (double i1, double i2)
void | lowess (double *x, double *y, int *n, double *f, int *nsteps, double *delta, double *ys, double *rw, double *res)
static void | lowest (double *x, double *y, int n, double *xs, double *ys, int nleft, int nright, double *w, Rboolean userw, double *rw, Rboolean *ok)
static int | rcmp (double x, double y, Rboolean nalast)
static void | rPsort (double *x, int n, int k)

## Macro Definition Documentation

## FALSE

#define FALSE false

Referenced by TitlePicker::eventFilter(), and lowest().

## TRUE

#define TRUE true

Referenced by ApplicationWindow::dependingPlots(), TitlePicker::eventFilter(), Graph3D::eventFilter(), ApplicationWindow::initPlot3DToolBar(), lowest(), rPsort(), ApplicationWindow::setBoxed3DPlot(), ApplicationWindow::setFramed3DPlot(), and MultiLayer::setNumLayers().

## Typedef Documentation

## Rboolean

typedef bool Rboolean

## Function Documentation

## clowess()

static void clowess | ( | double * | x,
|  | double * | y,
|  | int | n,
|  | double | f,
|  | int | nsteps,
|  | double | delta,
|  | double * | ys,
|  | double * | rw,
|  | double * | res
| ) |  |

static

References fsquare(), imax2(), imin2(), lowest(), and rPsort().

Referenced by lowess(), and SmoothFilter::smoothLowess().

## fcube()

static double fcube | ( | double | x | ) |

static

Referenced by lowest().

## fmax2()

static double fmax2 | ( | double | d1,
|  | double | d2
| ) |  |

static

Referenced by lowest().

## fsquare()

static double fsquare | ( | double | x | ) |

static

Referenced by clowess(), and lowest().

## imax2()

static double imax2 | ( | double | i1,
|  | double | i2
| ) |  |

static

Referenced by clowess().

## imin2()

static double imin2 | ( | double | i1,
|  | double | i2
| ) |  |

static

Referenced by clowess().

## lowess()

void lowess | ( | double * | x,
|  | double * | y,
|  | int * | n,
|  | double * | f,
|  | int * | nsteps,
|  | double * | delta,
|  | double * | ys,
|  | double * | rw,
|  | double * | res
| ) |  |

References clowess().

## lowest()

static void lowest | ( | double * | x,
|  | double * | y,
|  | int | n,
|  | double * | xs,
|  | double * | ys,
|  | int | nleft,
|  | int | nright,
|  | double * | w,
|  | Rboolean | userw,
|  | double * | rw,
|  | Rboolean * | ok
| ) |  |

static

References FALSE, fcube(), fmax2(), fsquare(), and TRUE.

Referenced by clowess().

## rcmp()

static int rcmp | ( | double | x,
|  | double | y,
|  | Rboolean | nalast
| ) |  |

static

Referenced by rPsort().

## rPsort()

static void rPsort | ( | double * | x,
|  | int | n,
|  | int | k
| ) |  |

static

References rcmp(), and TRUE.

Referenced by clowess().